/*
 * hal.h
 *
 *  Created on: 10.05.2011
 *      Author: AndreR
 */

#ifndef __HAL_H__
#define __HAL_H__

#include <avr/io.h>
#include <stdint.h>
#include "fixed.h"

#define LEDR	PD0
#define LEDG	PD1
#define CHG		PB1
#define FAN		PD3
#define DIS		PD5
#define EN_DIS1	PD6
#define EN_DIS2 PD7

void SetFanSpeed(uint8_t speed);
void EnableCharge(uint16_t onTicks, uint16_t offTicks);
void DisableCharge();
void EnableFire1(uint8_t level, FixedPoint142 duration);
void EnableFire2(uint8_t level, FixedPoint142 duration);
void DisableFire();
void CalcTimer(FixedPoint142 time, uint8_t* pPrescaler, uint16_t* pValue);

#endif /* HAL_H_ */
