/*
 * errors.h
 *
 *  Created on: 25.02.2011
 *      Author: AndreR
 */

#ifndef __ERRORS_H__
#define __ERRORS_H__

#define ERROR_NOT_ENOUGH_MEMORY						0x0001
#define ERROR_INVALID_HANDLE						0x0002

#define ERROR_FIFO_PACKET_SYNCED_NOT_ENOUGH_MEMORY	0x1000
#define ERROR_FIFO_PACKET_SYNCED_EMPTY				0x1001

#define ERROR_DECT_INVALID_MODE						0x0200
#define ERROR_DECT_BUFFER_TOO_SMALL					0x0201

#define ERROR_HDLC_INVALID_PACKET					0x0300
#define ERROR_HDLC_BAD_CHECKSUM						0x0301

#define ERROR_ETHERNET_BAD_FRAME					0x0400
#define ERROR_ETHERNET_UNSUPPORTED_PROTOCOL 		0x0401
#define ERROR_ETHERNET_NOT_ADDRESSED				0x0402

#define ERROR_ARP_NOT_SUPPORTED						0x0500
#define ERROR_ARP_BAD_PACKET						0x0501

#define ERROR_IPV4_BAD_PACKET						0x0600
#define ERROR_IPV4_NOT_SUPPORTED					0x0601
#define ERROR_IPV4_BAD_CHECKSUM						0x0602

#define ERROR_UDP_BAD_PACKET						0x0700

#define ERROR_NETWORK_HEADLESS						0x0800

// 0x0900 reserved for ATISP
#define ERROR_ATMEGA_MODE_FAULT						0x0910
#define ERROR_ATMEGA_OUT_OF_SYNC					0x0911
#define ERROR_ATMEGA_TIMEOUT						0x0912
#define ERROR_ATMEGA_UNKOWN_SIGNATURE				0x0913
#define ERROR_ATMEGA_PROGRAM_TOO_BIG				0x0914
#define ERROR_ATMEGA_VERIFICATION_FAILED			0x0915
#define ERROR_ATMEGA_EXCHANGE_CRC_WRONG				0x0916
#define ERROR_ATMEGA_EXCHANGE_FLAG_MISMATCH			0x0917

#define ERROR_SPI_NO_FREE_SLOT						0x0A00
#define ERROR_SPI_EXCLUSIVE_LOCK					0x0A01
#define ERROR_SPI_INVALID_LENGTH					0x0A02
#define ERROR_SPI_INVALID_SLAVE						0x0A03
#define ERROR_SPI_BUSY								0x0A04

#define ERROR_IGMP_BAD_PACKET						0x0B00
#define ERROR_IGMP_BAD_CHECKSUM						0x0B01

#define ERROR_FIFO_SYNCED_EMPTY						0x0C00
#define ERROR_FIFO_SYNCED_NOT_ENOUGH_MEMORY			0x0C01

#define ERROR_CONSOLE_NO_FREE_SLOT					0x0D00
#define ERROR_CONSOLE_NO_CMD_READY					0x0D01

#endif
