/*
 * kicker.h
 *
 *  Created on: 19.03.2011
 *      Author: AndreR
 */

#ifndef __KICKER_H__
#define __KICKER_H__

#include "stm32f10x.h"

#include "util/atmega.h"
#include "atmega/kicker_prog/kicker_data.h"

#include "FreeRTOS.h"
#include "semphr.h"

#include "commands.h"

#define KICKER_MODE_FORCE		0
#define KICKER_MODE_ARM			1
#define KICKER_MODE_DISARM		2

typedef struct _Kicker
{
	KickerData data;
	uint8_t rxData[KICKER_DATA_SIZE+1];
	uint8_t txData[KICKER_DATA_SIZE+1];

	ATMega atmega;

	xSemaphoreHandle hDataInUse;
	xSemaphoreHandle hNewCommand;

	KickerStatusV2 latestStatus;

	uint8_t logEnabled;
} Kicker;

extern Kicker kicker;

void KickerInit();
void KickerTask(void* params);
void KickerLoadManual(uint16_t tOn, uint16_t tOff, uint16_t duration);
void KickerLoadAuto(uint16_t maxCap);
void KickerFire(uint16_t duration, uint8_t tOn, uint8_t device);
void KickerSetFan(uint8_t mode, uint8_t speed);
void KickerSetLogging(uint8_t enable);

#endif
