/*
 * fifo_packet.h
 *
 *  Created on: 13.02.2011
 *      Author: AndreR
 */

#ifndef __FIFO_PACKET_H__
#define __FIFO_PACKET_H__

#include "fifo8.h"

#include "stm32f10x.h"

#define ERROR_FIFO_PACKET_NOT_ENOUGH_MEMORY 0x0100
#define ERROR_FIFO_PACKET_EMPTY 0x0101

#define FIFO_PACKET_HEADER_SIZE 2

typedef struct _FifoPacket
{
	Fifo8 fifo;

	volatile uint16_t numPackets;
} FifoPacket;

void		FifoPacketInit(FifoPacket* pFifo, uint8_t* pBuf, uint16_t size);
void		FifoPacketClear(FifoPacket* pFifo);
int16_t		FifoPacketPush(FifoPacket* pFifo, uint16_t packetLength, uint8_t* pData);
int16_t		FifoPacketPop(FifoPacket* pFifo, uint16_t* pPacketLength, uint8_t* pData, uint16_t suppliedLength);
int16_t		FifoPacketDrop(FifoPacket* pFifo);
int16_t		FifoPacketGetNextPacketDataLength(FifoPacket* pFifo, uint16_t* pLength);
uint16_t	FifoPacketNumPackets(FifoPacket* pFifo);

#endif
