/*
 * *********************************************************
 * Copyright (c) 2009 - 2010, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - RCU
 * Date: 20.10.2010
 * Author(s): Lukas
 * 
 * *********************************************************
 */

package edu.dhbw.mannheim.tigers.robotcontrolutility.model;

import java.io.*;
import java.net.NoRouteToHostException;
import java.net.SocketTimeoutException;

import org.apache.log4j.Logger;

import edu.dhbw.mannheim.tigers.robotcontrolutility.presenter.RCUPresenter;


/**
 * This class opens SendingThreads that connect to Sumatra.
 * 
 * @author Lukas
 * 
 */

public class ActionSender
{
	// --------------------------------------------------------------------------
	// --- instance variables ---------------------------------------------------
	// --------------------------------------------------------------------------
	
	private SendingThread	sendingThread	= null;
	
	// --- logger ---
	private Logger				log				= Logger.getLogger(RCUPresenter.class.getName());
	
	
	// --------------------------------------------------------------------------
	// --- constructor(s) -------------------------------------------------------
	// --------------------------------------------------------------------------
	public ActionSender()
	{
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	public boolean startSending(String serverName, int port)
	{
		try
		{
			sendingThread = new SendingThread(serverName, port);
			sendingThread.setName("SendingThread on Port: " + port);
		} catch (NoRouteToHostException e)
		{
			return false;
		} catch (SocketTimeoutException e)
		{
			log.error("Timeout: Perhaps Server isn't set up.");
			return false;
		} catch (IOException e)
		{
			e.printStackTrace();
			return false;
		}
		sendingThread.start();
		return true;
	}
	

	public void stopSending()
	{
		sendingThread.close();
	}
	

	public void setNewCmd(ActionCommand newCmd)
	{
		sendingThread.setNewCmd(newCmd);
	}
}
