/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package edu.dhbw.mannheim.tigers.sim.engine.model.data;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.IDataFactory
 * @model kind="package"
 * @generated
 */
public interface IDataPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "data";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "edu.dhbw.mannheim.tigers.sim.engine.model.data";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "data";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	IDataPackage eINSTANCE = edu.dhbw.mannheim.tigers.sim.engine.model.data.impl.DataPackageImpl.init();

	/**
	 * The meta object id for the '{@link edu.dhbw.mannheim.tigers.sim.engine.model.data.impl.ModelDataStorageImpl <em>Model Data Storage</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.impl.ModelDataStorageImpl
	 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.impl.DataPackageImpl#getModelDataStorage()
	 * @generated
	 */
	int MODEL_DATA_STORAGE = 0;

	/**
	 * The feature id for the '<em><b>CT Bot Data</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DATA_STORAGE__CT_BOT_DATA = 0;

	/**
	 * The feature id for the '<em><b>Ball Data</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DATA_STORAGE__BALL_DATA = 1;

	/**
	 * The feature id for the '<em><b>Field Data</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DATA_STORAGE__FIELD_DATA = 2;

	/**
	 * The feature id for the '<em><b>Tiger Bot Data</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DATA_STORAGE__TIGER_BOT_DATA = 3;

	/**
	 * The number of structural features of the '<em>Model Data Storage</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DATA_STORAGE_FEATURE_COUNT = 4;

	/**
	 * Returns the meta object for class '{@link edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage <em>Model Data Storage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Data Storage</em>'.
	 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage
	 * @generated
	 */
	EClass getModelDataStorage();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage#getCTBotData <em>CT Bot Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>CT Bot Data</em>'.
	 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage#getCTBotData()
	 * @see #getModelDataStorage()
	 * @generated
	 */
	EReference getModelDataStorage_CTBotData();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage#getBallData <em>Ball Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Ball Data</em>'.
	 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage#getBallData()
	 * @see #getModelDataStorage()
	 * @generated
	 */
	EReference getModelDataStorage_BallData();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage#getFieldData <em>Field Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Field Data</em>'.
	 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage#getFieldData()
	 * @see #getModelDataStorage()
	 * @generated
	 */
	EReference getModelDataStorage_FieldData();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage#getTigerBotData <em>Tiger Bot Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Tiger Bot Data</em>'.
	 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.IModelDataStorage#getTigerBotData()
	 * @see #getModelDataStorage()
	 * @generated
	 */
	EReference getModelDataStorage_TigerBotData();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	IDataFactory getDataFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link edu.dhbw.mannheim.tigers.sim.engine.model.data.impl.ModelDataStorageImpl <em>Model Data Storage</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.impl.ModelDataStorageImpl
		 * @see edu.dhbw.mannheim.tigers.sim.engine.model.data.impl.DataPackageImpl#getModelDataStorage()
		 * @generated
		 */
		EClass MODEL_DATA_STORAGE = eINSTANCE.getModelDataStorage();

		/**
		 * The meta object literal for the '<em><b>CT Bot Data</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_DATA_STORAGE__CT_BOT_DATA = eINSTANCE.getModelDataStorage_CTBotData();

		/**
		 * The meta object literal for the '<em><b>Ball Data</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_DATA_STORAGE__BALL_DATA = eINSTANCE.getModelDataStorage_BallData();

		/**
		 * The meta object literal for the '<em><b>Field Data</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_DATA_STORAGE__FIELD_DATA = eINSTANCE.getModelDataStorage_FieldData();

		/**
		 * The meta object literal for the '<em><b>Tiger Bot Data</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_DATA_STORAGE__TIGER_BOT_DATA = eINSTANCE.getModelDataStorage_TigerBotData();

	}

} //IDataPackage
