/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package edu.dhbw.mannheim.tigers.sim.settings.data.util;

import edu.dhbw.mannheim.tigers.sim.settings.data.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see edu.dhbw.mannheim.tigers.sim.settings.data.IDataPackage
 * @generated
 */
public class DataAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static IDataPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = IDataPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataSwitch<Adapter> modelSwitch =
		new DataSwitch<Adapter>() {
			@Override
			public Adapter caseSimProperties(ISimProperties object) {
				return createSimPropertiesAdapter();
			}
			@Override
			public Adapter caseMatchModeProperties(IMatchModeProperties object) {
				return createMatchModePropertiesAdapter();
			}
			@Override
			public Adapter caseTestModeProperties(ITestModeProperties object) {
				return createTestModePropertiesAdapter();
			}
			@Override
			public Adapter caseShooterModeProperties(IShooterModeProperties object) {
				return createShooterModePropertiesAdapter();
			}
			@Override
			public Adapter caseCamProperties(ICamProperties object) {
				return createCamPropertiesAdapter();
			}
			@Override
			public Adapter caseSimEngineProperties(ISimEngineProperties object) {
				return createSimEnginePropertiesAdapter();
			}
			@Override
			public Adapter caseApplicationProperties(IApplicationProperties object) {
				return createApplicationPropertiesAdapter();
			}
			@Override
			public Adapter caseVisualizationProperties(IVisualizationProperties object) {
				return createVisualizationPropertiesAdapter();
			}
			@Override
			public Adapter caseTeamProperties(ITeamProperties object) {
				return createTeamPropertiesAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link edu.dhbw.mannheim.tigers.sim.settings.data.ISimProperties <em>Sim Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.dhbw.mannheim.tigers.sim.settings.data.ISimProperties
	 * @generated
	 */
	public Adapter createSimPropertiesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link edu.dhbw.mannheim.tigers.sim.settings.data.IMatchModeProperties <em>Match Mode Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.dhbw.mannheim.tigers.sim.settings.data.IMatchModeProperties
	 * @generated
	 */
	public Adapter createMatchModePropertiesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link edu.dhbw.mannheim.tigers.sim.settings.data.ITestModeProperties <em>Test Mode Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.dhbw.mannheim.tigers.sim.settings.data.ITestModeProperties
	 * @generated
	 */
	public Adapter createTestModePropertiesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link edu.dhbw.mannheim.tigers.sim.settings.data.IShooterModeProperties <em>Shooter Mode Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.dhbw.mannheim.tigers.sim.settings.data.IShooterModeProperties
	 * @generated
	 */
	public Adapter createShooterModePropertiesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link edu.dhbw.mannheim.tigers.sim.settings.data.ICamProperties <em>Cam Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.dhbw.mannheim.tigers.sim.settings.data.ICamProperties
	 * @generated
	 */
	public Adapter createCamPropertiesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link edu.dhbw.mannheim.tigers.sim.settings.data.ISimEngineProperties <em>Sim Engine Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.dhbw.mannheim.tigers.sim.settings.data.ISimEngineProperties
	 * @generated
	 */
	public Adapter createSimEnginePropertiesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link edu.dhbw.mannheim.tigers.sim.settings.data.IApplicationProperties <em>Application Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.dhbw.mannheim.tigers.sim.settings.data.IApplicationProperties
	 * @generated
	 */
	public Adapter createApplicationPropertiesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link edu.dhbw.mannheim.tigers.sim.settings.data.IVisualizationProperties <em>Visualization Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.dhbw.mannheim.tigers.sim.settings.data.IVisualizationProperties
	 * @generated
	 */
	public Adapter createVisualizationPropertiesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link edu.dhbw.mannheim.tigers.sim.settings.data.ITeamProperties <em>Team Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.dhbw.mannheim.tigers.sim.settings.data.ITeamProperties
	 * @generated
	 */
	public Adapter createTeamPropertiesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //DataAdapterFactory
