package edu.dhbw.mannheim.tigers.sim.controller;


/**
 * This is the interface for the controller of this application. Together with its {@link ASubController}s it handles
 * the applications state and de-/initialization.
 * 
 * @author Gero
 */
public interface IMainController {
	
	// --------------------------------------------------------------------------
	// --- application ----------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * Performs everything necessary to close the Sim
	 */
	public void doExitApp();
	

	// --------------------------------------------------------------------------
	// --- controller handling --------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * @return Returns the {@link ASubController} of type {@link MainController.Type#INPUT}
	 */
	public IInputController getInputController();
	

	/**
	 * @return Returns the {@link ASubController} of type {@link MainController.Type#ENGINE}
	 */
	public ISimEngineController getEngineController();
}
