package edu.dhbw.mannheim.tigers.sim.engine;


import java.util.Arrays;
import java.util.List;


/**
 * This class holds the logic for a certain state of the {@link SimEngine}. This is the 'state' of a simple
 * State-Machine-pattern. It is used for various reasons throughout the inner parts of the engine.
 * 
 * @author Gero
 */
public class ASimEngineState implements IUpdateableSimEnginePart, IRenderableSimEnginePart {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	private List<ESimEngineState>	states	= null;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	public ASimEngineState(ESimEngineState... newStates) {
		super();
		this.states = Arrays.asList(newStates);
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	@Override
	public void update(float interpolation, float tpf, float fps) {
	}
	

	@Override
	public void render(float interpolation) {
		
	}
	

	public List<ESimEngineState> getStates() {
		return states;
	}
}
