package edu.dhbw.mannheim.tigers.sim.engine;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;


/**
 * Defines the state the the {@link SimEngine} is in.
 * 
 * @author Gero
 */
public enum ESimEngineState {
	
	READY,
	RUNNING,
	PAUSED_FULL,
	PAUSED_SIMULATION,
	STOPPED;
	

	private static HashMap<String, ESimEngineState>	states;
	
	
	private ESimEngineState() {
		register(this);
	}
	

	private static void register(ESimEngineState newState) {
		if (states == null) {
			states = new HashMap<String, ESimEngineState>();
		}
		states.put(newState.toString(), newState);
	}
	

	public static ESimEngineState[] getStatesExceptPausedFull() {
		List<ESimEngineState> result = new ArrayList<ESimEngineState>(states.values());
		
		result.remove(PAUSED_FULL);
		
		return result.toArray(new ESimEngineState[result.size()]);
	}
}
