package edu.dhbw.mannheim.tigers.sim.engine;

import edu.dhbw.mannheim.tigers.sim.engine.modes.ASimEngineMode;


/**
 * Encapsulates the ability to populate a state-change and retrieve the current state from {@link ASimEngineMode}s.
 * 
 * @author Gero
 */
public interface IStatefulSimEngine {
	
	/**
	 * @return The {@link ESimEngineState} the {@link SimEngine} currently is in
	 */
	public ESimEngineState getState();
	

	/**
	 * Called from {@link SimEngine} if the state changes
	 * 
	 * @param newState
	 */
	public void changeStateTo(ESimEngineState newState);
}
