package edu.dhbw.mannheim.tigers.sim.engine;


/**
 * This interface encapsulates together with {@link ISimEngine} and {@link IRenderableSimEnginePart} inner
 * parts of the simulation which are capable of directly influencing it
 * 
 * @author Gero
 */
public interface IUpdateableSimEnginePart {
	
	/**
	 * @see SimEngine#update(float)
	 * 
	 * @param interpolation		(not used)
	 * @param tpc					Time per (simulation) cycle
	 * @param cps					(simulation) cycles per second
	 */
	public abstract void update(float interpolation, float tpc, float cps);
}