package edu.dhbw.mannheim.tigers.sim.engine.com.bot;

import java.io.IOException;


/**
 * Lets {@link ABotCommunicator} take some control over its 2nd part, the
 * {@link ABotStatusTransmitter}
 * 
 * @author Gero
 */
public interface IBotCommandTransmitter<S> {
	
	/**
	 * @param newInterval The new interval which is used for sending status-messages
	 */
	public void setStatusMessageInterval(int newInterval);
	
	
	/**
	 * Sends the given message to the connected bot
	 * 
	 * @param msg
	 * @throws IOException 
	 */
	public void send(S msg) throws IOException;
}
