package edu.dhbw.mannheim.tigers.sim.engine.delegates;

import java.text.SimpleDateFormat;
import java.util.Date;

import com.jme.input.InputHandler;
import com.jme.input.KeyInput;
import com.jme.input.action.InputAction;
import com.jme.input.action.InputActionEvent;

import edu.dhbw.mannheim.tigers.sim.Sim;
import edu.dhbw.mannheim.tigers.sim.engine.ICore;

/**
 * Provides the user the possibility to take a screenshot with a single keystroke
 * 
 * @author Gero
 */
public class ScreenshotDelegate extends ASimDelegate {
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	  * @see ScreenshotDelegate
	  * @param core
	  */
	public ScreenshotDelegate(ICore core) {
		super(core);
	}
	
	
	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	@Override
	public void initSimulation() {
		core.getInputHandler().addAction(new InputAction() {
			@Override
			public void performAction(InputActionEvent evt) {
				if (!evt.getTriggerPressed()) {
					SimpleDateFormat sd = new SimpleDateFormat("kk-mm-ss");
					String dateString = sd.format(new Date());
					String filename = Sim.SCREENSHOT_PATH + "screen_" + dateString;
					
					core.getDisplay().getRenderer().takeScreenShot(filename);
					
					log.info("Screenshot saved. Loacation: " + filename);
				}
			}
		}, InputHandler.DEVICE_KEYBOARD, KeyInput.KEY_F12, InputHandler.AXIS_NONE, false);
	}
}
