package edu.dhbw.mannheim.tigers.sim.engine.model;

import com.jme.math.FastMath;


/**
 * This class provides some static methods for conversion between different coordinate systems.
 * 
 * @author Gero
 */
public class CoordinateConversionHelper {

	
   /**
    * @param value
    * @param offset
    * @return The value shifted by offset and adjusted to -PI < value < PI
    */
   public static float shiftRadians(float value, float offset) {
   	
      // Apply offset
      value += offset;
      
      // Adjust values to -PI < value < PI
      value += FastMath.PI;
      value %= FastMath.TWO_PI;
      if (value < 0) {
      	value = FastMath.PI - (-value);
      } else {
      	value -= FastMath.PI;
      }
      
      return value;
   }
   
   
   /**
    * @param value
    * @return Value shifted into the range between 0 and {@link FastMath#TWO_PI}
    */
   public static float toTwoPiRange(float value) {
      
      float result = value;
      if (value < 0) {
         result += FastMath.TWO_PI;
      }
      
      return result;
   }
}
