package edu.dhbw.mannheim.tigers.sim.engine.model.bot;

import java.io.Serializable;

import edu.dhbw.mannheim.tigers.sim.engine.com.ERoboCupTeam;


/**
 * The unique identifier for each bot
 * 
 * @author Gero
 */
public class BotID implements Serializable {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	private static final long	serialVersionUID	= 4226201192476883325L;
	
	private final int				id;
	private final ERoboCupTeam	team;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * @see BotID
	 * @param id
	 * @param team
	 */
	BotID(int id, ERoboCupTeam	team) {
		this.id = id;
		this.team = team;
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	public int getIntValue() {
		return id;
	}
	
	
	public ERoboCupTeam getTeam() {
		return this.team;
	}
	

	@Override
	public boolean equals(Object obj) {
		boolean equal = false;
		
		if (obj != null) {
			
			if (obj.getClass().equals(getClass())) {
				BotID otherID = (BotID) obj;
				equal = otherID.getIntValue() == getIntValue() && otherID.team.equals(team);
			} else {
				equal = super.equals(obj);
			}
		}
		
		return equal;
	}
	

	@Override
	public int hashCode() {
		return getIntValue() + 17 * team.ordinal();
	}
	

	@Override
	public String toString() {
		return "[BotID: " + getIntValue() + "|" + (team == ERoboCupTeam.BLUE_TEAM ? "B" : "Y") + "]";
	}
}
