package edu.dhbw.mannheim.tigers.sim.engine.model.bot;


import com.jme.scene.Node;
import com.jmex.physics.DynamicPhysicsNode;

import edu.dhbw.mannheim.tigers.sim.engine.model.bot.parts.ABotModelPart;
import edu.dhbw.mannheim.tigers.sim.engine.model.bot.parts.IBotModelPart;


/**
 * This is a interface of the {@link ABotModel} that encapsulates the behavior that is necessary
 * for using {@link ABotModelPart}s.
 * 
 * @author Gero
 */
public interface IBotPartsOwner {
   
   /**
    * Adds a {@link DynamicPhysicsNode} to the {@link ABotModel}
    * 
    * @param node
    */
   public void addPhysicNode(DynamicPhysicsNode node);

   
   /**
    * Attaches the given {@link Node} to the {@link Node} defining the {@link ABotModel}
    * 
    *  @param node
    */
   public void attachNode(Node node);
	
	
	/**
	 * Adds the given {@link IBotModelPart} to the 
	 * @param part
	 */
	public void addModelPart(IBotModelPart part);
}
