package edu.dhbw.mannheim.tigers.sim.engine.observer;

import java.util.concurrent.ExecutorService;

import edu.dhbw.mannheim.tigers.sim.engine.ESimEngineState;
import edu.dhbw.mannheim.tigers.sim.engine.SimEngine;
import edu.dhbw.mannheim.tigers.sim.util.activeobserver.AActiveObserver;



/**
 * This is the base class for observers that are listening to the {@link SimEngine}s state
 * 
 * @author Gero
 */
public abstract class ASimEngineObserver extends AActiveObserver<ISimEngineObservable, ISimEngineObserver, ESimEngineState> implements ISimEngineObserver {

	/**
	  * @see ASimEngineObserver
	  * @param newExService
	  * @param oneThreadPerCall
	  * @param name
	  */
	public ASimEngineObserver(ExecutorService newExService, boolean oneThreadPerCall, String name) {
		super(newExService, oneThreadPerCall, name + " <= SimEngine");
	}
}
