package edu.dhbw.mannheim.tigers.sim.gui.swing;


import edu.dhbw.mannheim.tigers.sim.engine.ESimEngineState;
import edu.dhbw.mannheim.tigers.sim.engine.modes.ESimEngineMode;


/**
 * This interface encapsulates GUI-parts which are capable of displaying {@link ESimEngineState}s and to get a feedback
 * from the user which one {@link ESimEngineMode} to choose
 * 
 * @author Gero
 * 
 */
public interface IGUIEngineControl {
	
	/**
	 * Called whenever the model changes its state
	 * 
	 * @param newState
	 */
	public abstract void refresh(ESimEngineState newState);
	

	/**
	 * @return The user-chosen mode
	 */
	public ESimEngineMode getSelectedMode();
}