package edu.dhbw.mannheim.tigers.sim.resources;

import java.awt.Image;

import javax.swing.ImageIcon;

import edu.dhbw.mannheim.tigers.sim.exceptions.SimResourceException;
import edu.dhbw.mannheim.tigers.sim.resources.ImageProvider.EImage;


/**
 * Provides a set of {@link ImageIcon}s / {@link Image}s / {@link com.jme.image.Image}s, mainly for the GUI
 * 
 * @author Gero
 */
public interface IImageProvider extends IResourceProvider {
	
	public static final IImageProvider	INSTANCE	= ImageProvider.getInstance();
	
	
	/**
	 * @param key
	 * @return The {@link ImageIcon} mapped to the given key
	 * @throws SimResourceException If the given key is not associated to anything
	 */
	public abstract ImageIcon getIcon(EImage key) throws SimResourceException;
	

	/**
	 * @param key
	 * @return The {@link Image} mapped to the given key
	 * @throws SimResourceException If the given key is not associated to anything
	 */
	public abstract Image getImage(EImage key) throws SimResourceException;
	

	/**
	 * @param key
	 * @return The {@link com.jme.image.Image} mapped to the given key
	 * @throws SimResourceException If the given key is not associated to anything
	 */
	public abstract com.jme.image.Image getImageJME(EImage key) throws SimResourceException;
}