package edu.dhbw.mannheim.tigers.sim.util.activeobserver;


/**
 * This encapsulates the capabilities of the {@link AActiveObserver}
 * 
 * @author Gero
 * 
 * @param <S>
 * @param <O>
 * @param <E>
 */
public interface IActiveObserver<S extends IActiveObservable<S, O, E>, O extends IActiveObserver<S, O, E>, E> {
	
	/**
	 * Calls the Observer with the observable and the event
	 * 
	 * @param observable
	 */
	public abstract void update(S observable, E event);
	

	/**
	 * Called whenever an observer is added
	 */
	public abstract void onAdd();
	

	/**
	 * Called whenever an observer is removed
	 */
	public abstract void onRemove();
	
}